Đến nội dung


Hình ảnh
- - - - -

[Yêu câu] cần hướng dẫn giúp gộp file.dcl vào trong file.lsp


  • Please log in to reply
28 replies to this topic

#21 nguyenbd1

nguyenbd1

    biết lệnh text

  • Members
  • PipPipPipPip
  • 276 Bài viết
Điểm đánh giá: 13 (tàm tạm)

Đã gửi 03 December 2014 - 06:43 PM

nhờ anh em xem hộ file dcl gop vào file lisp nó bi lỗi gìhttp://www.cadviet.c...22369_vidu1.lsp


  • 0

#22 Doan Van Ha

Doan Van Ha

    biết lệnh adcenter

  • CADViet Team
  • PipPipPipPipPipPipPip
  • 5447 Bài viết
Điểm đánh giá: 2624 (tuyệt vời)

Đã gửi 03 December 2014 - 08:07 PM

Bị lỗi gì thì ít nhất bạn cũng nói sơ sơ qua chứ, sao lại hỏi mông lung như vậy?

Bạn post bài nhiều rồi mà không biết forum bị lỗi là không thể down file *.lsp hay sao? Cho nó vào thẻ code đi.


  • 0

* Chỉ nên yêu cầu Lisp khi bạn làm việc đó mất cả ngày nhưng họ chỉ viết 1 giờ. Đừng nêu yêu cầu Lisp khi bạn chỉ làm 1 giờ nhưng bắt họ phải mất cả ngày.

* Nhờ viết lisp cũng như đi khám bệnh. Chỉ gởi căn cước và than sắp chết thì không bác sỹ nào cứu sống được.


#23 nguyenbd1

nguyenbd1

    biết lệnh text

  • Members
  • PipPipPipPip
  • 276 Bài viết
Điểm đánh giá: 13 (tàm tạm)

Đã gửi 03 December 2014 - 08:12 PM

Bị lỗi gì thì ít nhất bạn cũng nói sơ sơ qua chứ, sao lại hỏi mông lung như vậy?

Bạn post bài nhiều rồi mà không biết forum bị lỗi là không thể down file *.lsp hay sao? Cho nó vào thẻ code đi.

(DEFUN  C:1(/ fname fn create_dialog)
(defun create_dialog ()
(setq fname (vl-filename-mktemp "cuatui.dcl"))
(setq fn (open fname "w"))
(write-line "
cuatui : dialog {
{label=\"TEU CHUAN LUC GIAC : Ban noi buon cho nhung ke thua vui\ ";
  :row {

:column
  {label="                         QC      BUOC              KH1    KH2:";
   :button{label="M2      0.5p                   1.6      4.5 ";}
   :button{label="M3       0.5p                   2.5      6 ";}
   :button{label="M4       0.7p                   3.3      8";}
   :button{label="M5       0.8p                  4.2      9";}
   :button{label="M6       1p                     5.0      11";}
   :button{label="M8       1.25p                6.8      14";}
   :button{label="M10       1.5p                 8.5      17";}
   :button{label="M12       1.75p            10.3      19";}
                        :button{label="M14      2p                  12      22 ";}
   :button{label="M16       2p                   14      24";}
   :button{label="M18       2.5p                   15.5      27";}
   :button{label="M20       2.5p                   17.5      31";}
   :button{label="M22       2.5p                   19.5      34";}
   :button{label="M24       3p                         21      37";}
   :button{label="M30       3.5p                   26.5      46";}
   :button{label="M33       3.5p                  26.5      46";}
                        :button{label="M36      3.5p                    32      46 ";}
         }
:column
  {label="                                QC          BUOC              KH1    KH2:";
   :button{label="1/8(3.18)      G40                  2,5      6 ";}
   :button{label="3/16(4.76)   G24                  3,4      8.5 ";}
   :button{label="1/4(6.35)       G20                4,7      11";}
   :button{label="5/16(7.94)       G18                 6,1      14";}
   :button{label="3/8(9.53)       G16                   7,5      15";}
   :button{label="7/16(11.11)       G14               8.8      19";}
   :button{label="1/2(12.7)      G12                 10      20";}
   :button{label="9/16(14.29)       G12              11.6      20";}
                        :button{label="5/8(15.88)      G11                  13      24 ";}
   :button{label="3/4(19.05)       G10               15.8      31";}
   :button{label="7/8(22.22)       G9                18,6      37";}
   :button{label="1(25.4)       G8                21,3      37";}   
         }}
ok_cancel;    

}
" fn)
(close fn))
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(create_dialog)
(setq dcl_id (load_dialog fname))
(if (not (new_dialog "cuatui" dcl_id))
(exit)))
)

 

 

xin lỗi bác hà


  • 0

#24 thanhduan2407

thanhduan2407

    biết lệnh adcenter

  • Advance Member
  • PipPipPipPipPipPipPip
  • 992 Bài viết
Điểm đánh giá: 223 (khá)

Đã gửi 03 December 2014 - 09:26 PM

Không biết mọi người có tham khảo được gì ở LISP này không? 

;;;TAO TEXTSTYLE
(command "-Style" "Times New Roman"  "Times New Roman" 0 1 0 "" "" "" )
(vl-load-com)
;;;KHI LOAD LISP SE HIEN LEN THONG BAO TEN LENH
(Prompt (strcat "\nL\U+1EC7nh ghi ch\U+00FA Text l\U+00E0: GCT2"))

(defun C:GCT2(  / file tmp dch return );;;;;;;GHI CHU TEXT CACH 2
    (cond
      (
        (not
          (and (setq file (open (setq tmp (vl-filename-mktemp nil nil ".dcl")) "w"))
            (write-line
              (strcat
	"	GHICHU"
	"	: dialog"
	"	{"
	"	label = \"Ch\U+01B0\U+01A1ng tr\U+00ECnh vi\U+1EBFt ghi ch\U+00FA Text\";"
	"	            : boxed_column"
	"	            {"
	"	                        : edit_box"
	"	                        {"
	"	                            label = \"Nh\U+1EADp t\U+00EAn c\U+1EA7n vi\U+1EBFt ghi ch\U+00FA\";key = \"Text_ghichu\"; edit_width = 25; alignment = left; value = \"Nh\U+1EADp n\U+1ED9i dung ghi ch\U+00FA v\U+00E0o \U+0111\U+00E2y\";"
	"	                        }"
	"	                        : edit_box"
	"	                        {"
	"	                            label = \"Nh\U+1EADp chi\U+1EC1u cao ch\U+1EEF:\"; key = \"Height_Text\"; edit_width = 3.0; alignment = left; value = 1;"
	"	                        }"
	"	            }"
	"	            : boxed_column"
	"	            {"
	"	            : row"
	"	                        {"
	"	                         : column"
	"	                         {"
	"	                              : popup_list"
	"	                              {"
	"	                                  label = \"L\U+1EF1a ch\U+1ECDn Layer\" ; key = \"LTSLAY\" ; edit_width  = 25 ; list = \"\" ; alignment = left;"
	"	                              }"
	"	                              : popup_list"
	"	                              {"
	"	                                  label = \"L\U+1EF1a ch\U+1ECDn TextStyle\" ; key = \"LTSTEXTSTYLE\" ; edit_width  = 25 ; list = \"\" ; alignment = left;"
	"	                              }"
	"				      spacer;spacer;"
	"				      :row"
	"				      { "
	"					: text"
	"					{"
	"						label = \"Ch\U+1ECDn Color\"; alignment =left;"
	"					}"
	"					: image_button"
	"					{"
	"						key = \"color\"; alignment = centered; height = 1.5; width = 1.0;	fixed_width = false;   fixed_height = true;"
	"					}"
	"				       }"
	"		                         }"
	"	                        }"
	"	            }"
	"	spacer;"
	"	            ok_cancel;"
	"	spacer;spacer;"
	"	:text"
	"	{"
	"		label= \"Ng\U+01B0\U+1EDDi vi\U+1EBFt: Nguy\U+1EC5n Th\U+00E0nh Du\U+00E2n - \U+0110\U+1ECBa Ch\U+00EDnh K48 - 0972.0168.25\";"
	"		alignment= left;"
	"	}"
	"	}"
              )
              file
            )
            (not (close file)) (< 0 (setq dch (load_dialog tmp))) (new_dialog "GHICHU" dch)
          )
        )
      )
      (t
		(action_tile "Text_ghichu"  "(setq TextGhiChu $value)")
		;;;;;;CHO PHEP NHAP NOI DUNG VAO
		(mode_tile "Text_ghichu" 2)
		;;;GAN BIEN CHO TEXTBOX CAO CHU
		(action_tile "Height_Text"  "(setq #Height $value)")
		;;;;;;CHO PHEP NHAP NOI DUNG VAO
		(mode_tile "Height_Text" 2)
		;;;TAO 1 DANH SACH CHUA CAC LAYER CO TRONG BAN VE
		(start_list "LTSLAY")
		(mapcar 'add_list (setq LstLayer (Getlayer)))
		(end_list)


		(if TextGhiChu
			(set_tile "Text_ghichu" TextGhiChu)
			(set_tile "Text_ghichu" "Nh\U+1EADp n\U+1ED9i dung ghi ch\U+00FA v\U+00E0o \U+0111\U+00E2y")
		)

		;;;;GAN LAYER 
		(if #CurLay
			(set_tile "LTSLAY" #CurLay)
			(set_tile "LTSLAY"  "0")
		)
       		(if #Height
			(set_tile "Height_Text" #Height)
			(set_tile "Height_Text"  "1.0")
		)
		(action_tile "LTSLAY" "(setq #CurLay $value)")
		;;;GAN MAU SAC
		(if (null #Color) (setq #Color 2))
		(fill-rec "color" #Color )
		(action_tile "color" "(if (setq #color (acad_colordlg #color)) (fill-rec \"color\" #color ))")
		 
		 ;;;;TAO 1 DANH SACH CHUA CAC TEXTSTYLE
		(start_list "LTSTEXTSTYLE")
		(mapcar 'add_list (setq LstTextStyle (GetTextStyle)))
		(end_list)
		  
		 ;;;;GAN TEXTSTYLE
		(if #CurStyle
			(set_tile "LTSTEXTSTYLE" #CurStyle)
			(set_tile "LTSTEXTSTYLE" "Standard")
		)

		  
		(action_tile "LTSTEXTSTYLE" "(setq #CurStyle $value)")
		;;;;GAN CAC BIEN CHO NOI DUNG GHI CHU, LAYER, TEXTSTYLE
		(if (not TextGhiChu) (setq TextGhiChu (get_tile "Text_ghichu")))
       		(if (not #Height) (setq #Height (get_tile "Height_Text")))
		(if (not #CurLay) (setq #CurLay (get_tile "LTSLAY")))
		(if (not #CurStyle) (setq #CurStyle (get_tile "LTSTEXTSTYLE")))
		;;;;GAN HANH DONG CHO BUTTON OK
		(action_tile "accept" "(setq userclick T)(done_dialog)")
		;;GAN HANH DONG CHO BUTTON CANCEL
		(action_tile "cancel" "(setq userclick nil)(done_dialog)(exit)")

        
      )
    )
    (start_dialog)
    (unload_dialog dch)
    (if (setq tmp (findfile tmp)) (vl-file-delete tmp))
	(if userclick
		(progn
			(GCT1 TextGhiChu #Height #CurLay #CurStyle #Color)
		 )
	)
  )


(defun Getlayer ( / lyr l)
(setq l nil)
(vlax-for lyr
	(vla-get-layers
		(vla-get-activedocument
			(vlax-get-acad-object)
		)
	)
	(setq l (cons (vla-get-name lyr) l))
)
  l
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;HAM CON - LAY RA CAC TEXTSTYLE CO TRONG BAN VE;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun GetTextStyle ( / styl_ l)
(setq l nil)
(vlax-for styl_
	(vla-get-textstyles
		(vla-get-activedocument
			(vlax-get-acad-object)
		)
	)
	(setq l (cons (vla-get-name styl_) l))
)
  l
)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;HAM CON GHI CHU TEXT;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun GCT1 (TextGhiChu h LayerText TextStyle col / i Olmode Gocxoay);;;;GHI CHU TEXT
(setq Olmode (getvar "OSMODE"))
(setvar "OSMODE" 0)
(while  (setq P1 (Getpoint "\nCh\U+1ECDn \U+0111i\U+1EC3m ch\U+00E8n TEXT ghi ch\U+00FA: "))
	(setq P2 (Getpoint  P1 "\nChon huong ghi chu TEXT: "))
	(setq Gocxoay (Angle (trans P1 1 0)
	                     (trans P2 1 0)
	              )
	)
	(entmake (list  (cons 0 "TEXT") (cons 10 P1) (cons 8 (nth (atoi LayerText) LstLayer))
			(cons 40 (atof h)) (cons 50 Gocxoay)
			(cons 7 (nth (atoi TextStyle) LstTextStyle)) (cons 1 TextGhiChu) (cons 62 col) ))
)
(setvar "OSMODE" Olmode)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;TAO MOT PICTURE BOX GAN MAU SAC;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun fill-rec (MyTile col / x y)
(start_image MyTile)
(setq x (dimx_tile MyTile) y (dimy_tile MyTile))
(fill_image 0 0 x y col)
(end_image)
)


  • 0



Tôi là con kiến bò trên sa mạc kiến thức bao la. Biển học thật rộng lớn







#25 nguyenbd1

nguyenbd1

    biết lệnh text

  • Members
  • PipPipPipPip
  • 276 Bài viết
Điểm đánh giá: 13 (tàm tạm)

Đã gửi 04 December 2014 - 10:24 AM

cảm ơn huynh. huynh co tàj ljệu về vấn de nay cho anh e tham khảo vớj
  • 0

#26 thanhduan2407

thanhduan2407

    biết lệnh adcenter

  • Advance Member
  • PipPipPipPipPipPipPip
  • 992 Bài viết
Điểm đánh giá: 223 (khá)

Đã gửi 04 December 2014 - 11:12 AM

Chỉ là bắt chước thôi bạn. Đừng tài liệu máy móc quá. Mình đọc hiểu và làm theo thôi.

Mình học mót là chính, chứ tìm tài liệu thì.....ít bạn ạ


  • 0



Tôi là con kiến bò trên sa mạc kiến thức bao la. Biển học thật rộng lớn







#27 nguyenbd1

nguyenbd1

    biết lệnh text

  • Members
  • PipPipPipPip
  • 276 Bài viết
Điểm đánh giá: 13 (tàm tạm)

Đã gửi 04 December 2014 - 02:25 PM

nhưng cũng có 1 số cái cơ bản. chja se cùng anh e dj huynh
  • 0

#28 Doan Van Ha

Doan Van Ha

    biết lệnh adcenter

  • CADViet Team
  • PipPipPipPipPipPipPip
  • 5447 Bài viết
Điểm đánh giá: 2624 (tuyệt vời)

Đã gửi 04 December 2014 - 03:28 PM

Không hứng lắm mỗi khi đọc bài của bạn, vì nhiều lý do khác nhau!

Sách học lisp hay học về dialog thì cụ Gồ có cả tủ đầy! Bạn cần chịu khó tìm thì nhiều lắm.

Đây là 1 cuốn, của bạn Thanhduan2407 đã post lên, trên 4r đã có nhưng tôi quên địa chỉ, nay tôi post lại đây.

http://www.cadviet.c..._hoc_dialog.pdf


  • 1

* Chỉ nên yêu cầu Lisp khi bạn làm việc đó mất cả ngày nhưng họ chỉ viết 1 giờ. Đừng nêu yêu cầu Lisp khi bạn chỉ làm 1 giờ nhưng bắt họ phải mất cả ngày.

* Nhờ viết lisp cũng như đi khám bệnh. Chỉ gởi căn cước và than sắp chết thì không bác sỹ nào cứu sống được.


#29 nguyenbd1

nguyenbd1

    biết lệnh text

  • Members
  • PipPipPipPip
  • 276 Bài viết
Điểm đánh giá: 13 (tàm tạm)

Đã gửi 05 December 2014 - 08:51 PM

Không hứng lắm mỗi khi đọc bài của bạn, vì nhiều lý do khác nhau!

Sách học lisp hay học về dialog thì cụ Gồ có cả tủ đầy! Bạn cần chịu khó tìm thì nhiều lắm.

Đây là 1 cuốn, của bạn Thanhduan2407 đã post lên, trên 4r đã có nhưng tôi quên địa chỉ, nay tôi post lại đây.

http://www.cadviet.c..._hoc_dialog.pdf

 cảm ơn bác nhiều. dù là không có hướng dẫn ghép file dlc vào lisp nhưng cũng giúp em rất nhiều về vấn đề hộp thoai dcl


  • 0